

void Help_Msg() {
  // display help messages when mouse is moving but not pressed
  if (mDown) {return;}
  Help$ = ""; // clear message when mouse is moving over the form

  // Processing logo
  if ((mX >= 749) && (mX <= 788) && (mY >= 12) && (mY <= 52)) {Help$ = "This Windows app was written in Processing v3.5.3";}
  
  // 'P' gain slider region?
  if ((mY >= 159) && (mY <= 196)) {
    if ((mX >=127) && (mX <=141)) {Help$ = "[Click] To decrement slider value";}
    else if ((mX >=639) && (mX <=654)) {Help$ = "[Click] To increment slider value";}
    else if ((mX >=155) && (mX <=635)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=675) && (mX <=764)) {Help$ = "PID P-gain slider value  -  [Click] to resend";}
  }

  // 'I' gain slider region?
  if ((mY >= 212) && (mY <= 249)) {
         if ((mX >=127) && (mX <=141)) {Help$ = "[Click] To decrement slider value";}
    else if ((mX >=639) && (mX <=654)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=155) && (mX <=635)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=675) && (mX <=764)) {Help$ = "PID I-gain slider value  -  [Click] to resend";}
  }

  // 'D' gain slider region?
  if ((mY >= 266) && (mY <= 303)) {
    if ((mX >=127) && (mX <=141)) {Help$ = "[Click] To decrement slider value";}
    else if ((mX >=639) && (mX <=654)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=155) && (mX <=635)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=675) && (mX <=764)) {Help$ = "PID D-gain slider value  -  [Click] to resend";}
  }

  // 'S' gain slider region?
  if ((mY >= 322) && (mY <= 363)) {
    if ((mX >=127) && (mX <=141)) {Help$ = "[Click] To decrement slider value";}
    else if ((mX >=639) && (mX <=654)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=155) && (mX <=635)) {Help$ = "[Click] To move and change slider value";}
    else if ((mX >=675) && (mX <=764)) {Help$ = "PID Speed-govenor slider value  -  [Click] to resend";}
  }

  // Buttons
  if ((mY >= 64) && (mY <= 143)) {
    // RESET button
    if ((mX >= 36) && (mX <= 114)) {Help$ = "[Click] to RESET values to defaults";}
  
    // I button
    if ((mX >= 136) && (mX <= 214)) {Help$ = "[Click] to toggle PID I-gain ON/OFF";}
  
    // D button
    if ((mX >= 218) && (mX <= 297)) {Help$ = "[Click] to toggle PID D-gain ON/OFF";}
  
    // Memory button
    if ((mX >= 300) && (mX <= 379)) {Help$ = "[Hold-down] to store current PID gains,      [Click] to recall them";}
  
    // PID setpoint jolt button
    if ((mX >= 380) && (mX <= 460)) {Help$ = "[Click] to toggle PID jolt function ON/OFF";}
  }
  
  if ((mY >= 384) && (mY <= 407)) {
    // COM port field
    if ((mX >= 88) && (mX <= 175)) {Help$ = "[Click-Left] to refresh USB port,      [Click-Right] to disconnect";}
  
    // Rx field
    if ((mX >= 240) && (mX <= 583)) {Help$ = "Text response messages recevied via USB from your Arduino";}
  
    // Tx field
    if ((mX >= 635) && (mX <= 763)) {Help$ = "Text control messages sent via USB to your Arduino";}
  }

  // Help field
  if ((mX >= 37) && (mX <= 635) && (mY >= 424) && (mY <= 448)) {Help$ = "Hello!";}

  // TechKnowTone
  if ((mX >= 670) && (mX <= 780) && (mY >= 440) && (mY <= 454)) {Help$ = "PID Controller v10  Released: " + Released$;}
  
  drawFlag = 1;
}

// ----------------------------------------------------------------------
